package zero1hd.rhythmbullet.audio.visualizer;

import java.util.concurrent.locks.ReentrantLock;

import com.badlogic.gdx.utils.Disposable;

import edu.emory.mathcs.jtransforms.fft.FloatFFT_1D;
import zero1hd.rhythmbullet.audio.MusicManager;

public class MusicManagerFFT implements Disposable {
	protected MusicManager mm;
	private FloatFFT_1D fft;
	private boolean calc;
	private ReentrantLock lock;
	protected float[] audioPCM;
	
	public MusicManagerFFT() {
		lock = new ReentrantLock();
	}
	
	public void calculate() {
		if (mm != null && calc && mm.isPlaying()) {
			lock.lock();
			fft.realForward(audioPCM);
			lock.unlock();
		}
	}
	
	public void setMM(MusicManager mm) {
		lock.lock();
		calc = false;
		if (audioPCM == null || audioPCM.length != mm.getReadWindowSize()) {
			audioPCM = new float[mm.getReadWindowSize()];
			fft = new FloatFFT_1D(mm.getReadWindowSize());
		}
		this.mm = mm;
		calc = true;
		lock.unlock();
	}
	
	@Override
	public void dispose() {
	}
	
	public MusicManager getMm() {
		return mm;
	}
	public float[] getAudioPCM() {
		return audioPCM;
	}
}
