package zero1hd.rhythmbullet.entity.enemies;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.utils.Pool.Poolable;

import zero1hd.rhythmbullet.entity.Entity;

public class Pellet extends Entity implements Poolable {
	
	@Override
	public void preInit() {
		sprite = new Sprite(assets.get("pellet.png", Texture.class));
		enemy = true;
		setSize(0.5f, 0.5f);
		sprite.setColor(0.5f, 1f, 1f, 0.5f);
		super.preInit();
	}
	
	@Override
	public void init(float deg, float speed, int hp) {
		this.speed = speed;
		this.angle = deg;
		super.init(deg, speed, hp);
	}
	
	
	@Override
	public void collided(Entity entity) {
		dead = true;
		super.collided(entity);
	}

	@Override
	public void reset() {
		dead = false;
		super.reset();
	}

}
