package zero1hd.rhythmbullet.desktop.audio.map;

import org.apache.commons.math3.random.MersenneTwister;

import com.badlogic.gdx.utils.FloatArray;

import zero1hd.rhythmbullet.audio.AudioDataPackage;
import zero1hd.rhythmbullet.entity.EntityManager;
import zero1hd.rhythmbullet.entity.coordinator.CoordinatorManager;
import zero1hd.rhythmbullet.game.EntitySpawnInfo;
import zero1hd.rhythmbullet.game.GamePlayMap;

public class RhythmMapAlgorithm implements Runnable {
	
	private EntityManager em;
	private CoordinatorManager cm;
	
	private FloatArray bassPeaks;
	private FloatArray mPeaks;
	private FloatArray umPeaks;
	private MersenneTwister rand;
	private GamePlayMap map;
	
	private float avgBass;
	private float avgUM;
	private float avgSPB;
	private float umMax, bassMax;
	
	private float speedMod, healthMod, difficultyMod;
	
	private float windowPerSecond;
	
	private volatile int progress;
	public RhythmMapAlgorithm(EntityManager em, CoordinatorManager cm, AudioDataPackage adp, float speedMod, float healthMod, float difficultyMod) {
		this.cm = cm;
		this.em = em;
		
		bassPeaks = adp.getBassPeaks();
		mPeaks = adp.getmPeaks();
		umPeaks = adp.getuMPeaks();
		map = new GamePlayMap(adp.getMusicInfo(), umPeaks.size);
		rand = new MersenneTwister(adp.getPUID());
		avgSPB = adp.getAvgSPB();
		windowPerSecond = 1/adp.getSecPerWin();
		
		this.speedMod = speedMod;
		this.healthMod = healthMod;
		this.difficultyMod = difficultyMod;
		
		umMax = adp.getuMMaxval();
		avgUM = adp.getuMAvg();

		bassMax = adp.getBassMaxVal();
		avgBass = adp.getBassAvg();
	}
	
	
	EntitySpawnInfo esi;
	@Override
	public void run() {
		map.beginBuild();
		//TODO Map gen algorithm
		map.endBuild();
	}
	
	public synchronized GamePlayMap getMap() {
		return map;
	}
	
	public synchronized int getProgress() {
		return progress;
	}
}
